﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace GGJ2015
{
    public static class GameFactory
    {
        static List<Type> allGameTypes;
        static Random rand;

        static GameFactory()
        {

            rand = new Random();

            // use the DLL of the project which is currently running
            var runningAssembly = Assembly.GetExecutingAssembly();

            // all classes have a "Type" which exposes information about the class
            var gameType = typeof(BaseGame);

            // to keep track of all organism classes that we've found.
            allGameTypes = new List<Type>();

            // go through all types in our project and locate those who inherit our 
            // basegame class
            foreach (var type in runningAssembly.GetTypes())
            {
                if (gameType.IsAssignableFrom(type))
                    allGameTypes.Add(type);
            }

            allGameTypes.Remove(gameType);
        }

        public static BaseGame NewGame()
        {
            // Find a random index here (do it yourself)
            var theRandomIndex = rand.Next(allGameTypes.Count());


            var selectedType = allGameTypes[theRandomIndex];

            // activator is a class in .NET which can create new objects 
            // with the help of a type
            return (BaseGame)Activator.CreateInstance(selectedType);
        }

        public static BaseGame NewGame(int index)
        {
            // Find a random index here (do it yourself)
            int theRandomIndex;

            if (index < allGameTypes.Count())
                theRandomIndex = index;
            else
                theRandomIndex = rand.Next(allGameTypes.Count());
            
            var selectedType = allGameTypes[index];

            // activator is a class in .NET which can create new objects 
            // with the help of a type
            return (BaseGame)Activator.CreateInstance(selectedType);
        }
    }
}
