﻿using IntelOrca.Launchpad;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace GGJ2015
{
    public abstract class BaseGame
    {
        protected LaunchpadDevice[] devices;
        public bool Ended { get; set; }

        public BaseGame()
        {
            Ended = true; 
        }

        public virtual void Start(LaunchpadDevice[] players)
        {
            devices = players;
            Ended = false;

            devices[0].DoubleBuffered = false;
            devices[0].ButtonPressed += launchpadDevice0_ButtonPressed;

            devices[1].DoubleBuffered = false;
            devices[1].ButtonPressed += launchpadDevice1_ButtonPressed;
            
        }

        protected abstract void launchpadDevice0_ButtonPressed(object sender, ButtonPressEventArgs e);
        

        protected abstract void launchpadDevice1_ButtonPressed(object sender, ButtonPressEventArgs e);

        public virtual void Update()
        {
            
        }
    }
}
