﻿using IntelOrca.Launchpad;
using Midi;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GGJ2015
{
    public static class LaunchpadHelper
    {

        public static void RapidUpdate(this LaunchpadDevice d, TileState[] grid)
        {
            for (int i = 0; i < 63; i += 2)
            {
                d.OutputDevice.SendNoteOn(Channel.Channel3, (Pitch)LaunchpadHelper.Light(grid[i]), LaunchpadHelper.Light(grid[i + 1]));
            }
            d.OutputDevice.SendControlChange(Channel.Channel1, (Control)9, 0);
        }

        public static int ToPos(this ButtonPressEventArgs e)
        {
            return (e.Y * 8 + e.X);
        }


        public static int Velocity(Brightness red, Brightness green = Brightness.OFF, Flags flag = Flags.NORMAL)
        {
            return (16 * (int)green) + (int)red + (int)flag;
        }

        public static int Light(TileState tile)
        {
            switch (tile)
            {
                case TileState.PLAYER1:
                    return Velocity(Brightness.FULL);
                case TileState.PLAYER2:
                    return Velocity(Brightness.OFF, Brightness.FULL);
                case TileState.BOTH:
                    return Velocity(Brightness.FULL, Brightness.FULL);
                default:
                    return Velocity(Brightness.OFF);
            }
        }

        public static TileState[] HappyFace = { TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.BOTH, TileState.BOTH, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY };

        public static TileState[] SadFace = { TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.BOTH, TileState.BOTH, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY, TileState.BOTH, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY,
                                TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY, TileState.EMPTY };
    }
}
