﻿using IntelOrca.Launchpad;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GGJ2015
{
    class Program
    {
        static void Main(string[] args)
        {
            LaunchpadDevice[] players = new LaunchpadDevice[2];
            BaseGame currentGame = GameFactory.NewGame();

            Console.WriteLine("Hello, and welcome...\n\n");
            
            try
            {
                for(int i = 0; i < players.Length; i++)
                {
                    players[i] = new LaunchpadDevice(i);
                    players[i].DoubleBuffered = true;
                }

                Console.WriteLine("Press any key to continue...\n\n");
                Console.ReadKey(true);

                Console.WriteLine("Launching...\n\n");
            }
            catch
            {
                Console.WriteLine("No launchpads found. Please check your connection\n\n");
                Console.ReadKey(true);
                return;
            }

            while(!Console.KeyAvailable)
            {
                if (currentGame == null || currentGame.Ended)
                {
                    currentGame = GameFactory.NewGame();
                    currentGame.Start(players);
                }

                currentGame.Update();
            }


            Console.WriteLine("See ya later");
            Console.ReadKey(true);

        }


    }
}
